Package org.optaplanner.core.impl.score.stream.bavet.bi

## Class BavetScoringBiNode<A,​B>

- java.lang.Object
- - org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode
  - - org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiNode<A,​B>
    - - org.optaplanner.core.impl.score.stream.bavet.bi.BavetScoringBiNode<A,​B>

- All Implemented Interfaces:
    `BavetNode`, `BavetScoringNode`

      public final class BavetScoringBiNode<A,​B>
      extends BavetAbstractBiNode<A,​B>
      implements BavetScoringNode

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode

      `nodeOrder, session`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BavetScoringBiNode​(BavetConstraintSession session, int nodeOrder, String constraintPackage, String constraintName, Score<?> constraintWeight, TriFunction<A,​B,​Consumer<Score<?>>,​UndoScoreImpacter> scoreImpacter)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ConstraintMatchTotal` | `buildConstraintMatchTotal​(Score<?> zeroScore)` |
    `BavetScoringBiTuple<A,​B>` | `createTuple​(BavetAbstractBiTuple<A,​B> parentTuple)` |
    `String` | `getConstraintId()` |
    `String` | `getConstraintName()` |
    `String` | `getConstraintPackage()` |
    `Score<?>` | `getConstraintWeight()` |
    `void` | `refresh​(BavetScoringBiTuple<A,​B> tuple)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.bi.BavetAbstractBiNode

      `addChildNode`

    - ### Methods inherited from class org.optaplanner.core.impl.score.stream.bavet.common.BavetAbstractNode

      `getNodeOrder`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.optaplanner.core.impl.score.stream.bavet.common.BavetNode

      `getNodeOrder`

- - ### Constructor Detail

    - #### BavetScoringBiNode

          public BavetScoringBiNode​(BavetConstraintSession session,
                                    int nodeOrder,
                                    String constraintPackage,
                                    String constraintName,
                                    Score<?> constraintWeight,
                                    TriFunction<A,​B,​Consumer<Score<?>>,​UndoScoreImpacter> scoreImpacter)

  - ### Method Detail

    - #### createTuple

          public BavetScoringBiTuple<A,​B> createTuple​(BavetAbstractBiTuple<A,​B> parentTuple)

      Specified by:
        `createTuple` in class `BavetAbstractBiNode<A,​B>`

    - #### refresh

          public void refresh​(BavetScoringBiTuple<A,​B> tuple)

    - #### buildConstraintMatchTotal

          public ConstraintMatchTotal buildConstraintMatchTotal​(Score<?> zeroScore)

      Specified by:
        `buildConstraintMatchTotal` in interface `BavetScoringNode`
      Parameters:
        `zeroScore` - never null
      Returns:
        never null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getConstraintPackage

          public String getConstraintPackage()

      Specified by:
        `getConstraintPackage` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintName

          public String getConstraintName()

      Specified by:
        `getConstraintName` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintId

          public String getConstraintId()

      Specified by:
        `getConstraintId` in interface `BavetScoringNode`
      Returns:
        never null

    - #### getConstraintWeight

          public Score<?> getConstraintWeight()

      Specified by:
        `getConstraintWeight` in interface `BavetScoringNode`
      Returns:
        never null